-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  5698-MMI
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- #   File Information: %W%
-- #   Revision: %I%
-- #   Date: %G% %U%
-- ############################################################################
----------------------------
-- File Name: HMI_m05_s010_dimension.db2
-- Last Modif: Feb 22 2002
-- Author: Frances Roberts
---------------------------


--------------------------------
--  HMI_m05_s010_dimension step
--------------------------------
---------------------------------
-- insert the metric dimension
------------------------------
-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(metric_id) from HMI.STAGE_D_MNW_METRIC)
where 
 extctl_source='HMI.STAGE_D_MNW_METRIC' and
 extctl_target='HMI.STAGE_D_MN_METRIC' and
 (select count(*) from HMI.STAGE_D_MNW_METRIC ) >0
;

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_d_mn_metric;

--#EXECUTE_AT_TARGET
create table hmi.stage_d_mn_metric (
 Metric_ID            INTEGER NOT NULL,
 Met_Category         VARCHAR(10) NOT NULL,
 Met_Name             VARCHAR(120) NOT NULL,
 Met_Desc							VARCHAR(254) NOT NULL,
 Met_Units            CHAR(6) NOT NULL,
 MIN_Exists           CHARACTER NOT NULL,
 MAX_Exists           CHARACTER NOT NULL,
 AVG_Exists           CHARACTER NOT NULL,
 Total_Exists         CHARACTER NOT NULL,
 Msrc_Nm							VARCHAR(6),
       PRIMARY KEY (Metric_ID)
);

--#INSERT_INTO_TARGET
insert into HMI.STAGE_D_MN_METRIC
select 
 d.metric_id as metric_id, 
 d.met_category as met_category,
 d.met_name as met_name,
 d.met_desc as met_desc,
 d.met_units as met_units,
 d.min_exists as min_exists,
 d.max_exists as max_exists,
 d.avg_exists as avg_exists,
 d.total_exists as total_exists,
 d.msrc_nm as msrc_nm
from
 HMI.STAGE_D_MNW_METRIC d,
 TWG.Extract_Control ec
where
 ec.extctl_source = 'HMI.STAGE_D_MNW_METRIC' and
 ec.extctl_target = 'HMI.STAGE_D_MN_METRIC' and
 d.metric_id > ec.extctl_from_intseq and
 d.metric_id <= ec.extctl_to_intseq 
;

--#EXECUTE_AT_TARGET
insert into HMI.D_MN_METRIC
select * from HMI.STAGE_D_MN_METRIC s
where not exists (
  select 1 from
  HMI.D_MN_METRIC t where
  t.metric_id = s.metric_id
)
;

-- confirm that the insertion of 
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm 
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'HMI.STAGE_D_MNW_METRIC' and
 ec.extctl_target = 'HMI.STAGE_D_MN_METRIC'
; 

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_d_cs_metric;

--#EXECUTE_AT_TARGET
create table hmi.stage_d_cs_metric (
 Metric_ID            INTEGER NOT NULL,
 Met_Category         VARCHAR(10) NOT NULL,
 Met_Name             VARCHAR(120) NOT NULL,
 Met_Desc			    		VARCHAR(254) NOT NULL,
 Met_Units            CHAR(6) NOT NULL,
 MIN_Exists           CHARACTER NOT NULL,
 MAX_Exists           CHARACTER NOT NULL,
 AVG_Exists           CHARACTER NOT NULL,
 Total_Exists         CHARACTER NOT NULL,
 Msrc_Nm							VARCHAR(6),
       PRIMARY KEY (Metric_ID)
);


-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(metric_id) from HMI.STAGE_D_CSW_METRIC)
where 
 extctl_source='HMI.STAGE_D_CSW_METRIC' and
 extctl_target='HMI.STAGE_D_CS_METRIC' and
 (select count(*) from HMI.STAGE_D_CSW_METRIC ) >0
;

--#INSERT_INTO_TARGET
insert into HMI.STAGE_D_CS_METRIC
select 
 d.metric_id as metric_id, 
 d.met_category as met_category,
 d.met_name as met_name,
 d.met_desc as met_desc,
 d.met_units as met_units,
 d.min_exists as min_exists,
 d.max_exists as max_exists,
 d.avg_exists as avg_exists,
 d.total_exists as total_exists,
 d.msrc_nm as msrc_nm
from
 HMI.STAGE_D_CSW_METRIC d,
 TWG.Extract_Control ec
where
 ec.extctl_source = 'HMI.STAGE_D_CSW_METRIC' and
 ec.extctl_target = 'HMI.STAGE_D_CS_METRIC' and
 d.metric_id > ec.extctl_from_intseq and
 d.metric_id <= ec.extctl_to_intseq 
;

--#EXECUTE_AT_TARGET
insert into HMI.D_CS_METRIC
select * from HMI.STAGE_D_CS_METRIC s
where not exists (
  select 1 from
  HMI.D_CS_METRIC t where
  t.metric_id = s.metric_id
)
;

-- confirm that the insertion of 
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'HMI.STAGE_D_CSW_METRIC' and
 ec.extctl_target = 'HMI.STAGE_D_CS_METRIC'
; 

---------------------------------
--  insert the dimension: hosts 
---------------------------------

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_d_hmi_host;

--#EXECUTE_AT_TARGET
create table HMI.stage_d_hmi_host(
 host_id     		integer not null,
 host_name    		varchar(254) not null,
 cust_nm		varchar(120) not null,
 centr_nm  		varchar(120) not null,
      primary key (host_id)
);

-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(comp_id) from twg.cur_comp )
where 
 extctl_source='TWG.CUR_COMP' and
 extctl_target='HMI.STAGE_D_HMI_HOST' and
 (select count(*) from twg.cur_comp where comptyp_cd = 'HMI_QMGR') >0 
;

--#INSERT_INTO_TARGET
insert into HMI.STAGE_D_HMI_Host
select 
 co2.comp_id as host_id,
 co2.comp_nm as host_name,
 cu1.cust_nm as cust_nm,
 ce1.centr_nm as centr_nm
from
 TWG.Cur_Comp co1,
 TWG.Cur_Comp co2,
 TWG.Cur_CompReln cr1,
 TWG.Cust cu1,
 TWG.Centr ce1,
 TWG.Extract_Control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_HMI_HOST' and
 co1.comp_id > ec.extctl_from_intseq and
 co1.comp_id <= ec.extctl_to_intseq and
 co1.comptyp_cd = 'HMI_QMGR' and
  cr1.comp_target_id = co1.comp_id and
 co2.comp_id = cr1.comp_source_id and
 co1.cust_id = cu1.cust_id and
--cu1.tmzon_id = z.tmzon_id and
 co1.centr_cd = ce1.centr_cd 
group by
--co.comp_id, co.comp_nm, cu1.cust_nm,  ce1.centr_nm , z.tmzon_nm 
	co2.comp_id, co2.comp_nm, cu1.cust_nm,  ce1.centr_nm 
;

--#EXECUTE_AT_TARGET
insert into HMI.D_HMI_HOST
select * from HMI.STAGE_D_HMI_HOST s
where not exists (
  select 1 from
  HMI.D_HMI_HOST t where
  t.host_id = s.host_id
)

;

-- confirm that the insertion of 
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm 
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_HMI_HOST'
; 

--------------------------------------
--  insert the dimension: monitor node 
--------------------------------------
--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_d_mn;

--#EXECUTE_AT_TARGET
create table HMI.stage_d_mn (
 mon_node_id				integer not null,
 mon_node_name       varchar(254) not null,
 msg_flow_name       varchar(254) not null,
 exec_group_name		varchar(254),
 broker_name  			varchar(254),
 qmgr_name	  			varchar(254),
   primary key (mon_node_id)
);


-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(comp_id) from twg.cur_comp where comptyp_cd = 'HMI_MONITOR_NODE' )
 
where 
 extctl_source='TWG.CUR_COMP' and
 extctl_target='HMI.STAGE_D_MN' and
 (select count(*) from twg.cur_comp where comptyp_cd = 'HMI_MONITOR_NODE') >0 
;

--#INSERT_INTO_TARGET
insert into HMI.STAGE_D_MN
select 
 co1.comp_id as mon_node_id,
 co1.comp_nm as mon_node_name, 
 co2.comp_nm as msg_flow_name, 
 co3.comp_nm as exec_group_name, 
 co4.comp_nm as broker_name, 
 co5.comp_nm as qmgr_name
 
from
 TWG.cur_Comp co1,
 TWG.cur_Comp co2,
 TWG.cur_Comp co3,
 TWG.cur_Comp co4,
 TWG.cur_Comp co5,
 TWG.cur_CompReln cr1,
 TWG.cur_CompReln cr2,
 TWG.cur_CompReln cr3,
 TWG.cur_CompReln cr4,
 TWG.cur_CompReln cr5,
 TWG.Extract_Control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_MN' and
 co1.comp_id > ec.extctl_from_intseq and
 co1.comp_id <= ec.extctl_to_intseq and
 co1.comptyp_cd = 'HMI_MONITOR_NODE' and
 cr1.comp_target_id = co1.comp_id and
 cr2.comp_target_id = cr1.comp_source_id and
 co2.comp_id = cr1.comp_source_id and
 cr3.comp_target_id = cr2.comp_source_id and
  co3.comp_id = cr2.comp_source_id and
 cr4.comp_target_id = cr3.comp_source_id and
  co4.comp_id = cr3.comp_source_id and
cr5.comp_target_id = cr4.comp_source_id and
  co5.comp_id = cr4.comp_source_id 	
group by
 co1.comp_id, co1.comp_nm, co2.comp_id, co2.comp_nm, co3.comp_id,  co3.comp_nm, co4.comp_id, co4.comp_nm, co5.comp_id, co5.comp_nm    
;

--#EXECUTE_AT_TARGET
insert into HMI.D_MONITOR_NODE
select * from HMI.STAGE_D_MN s
where not exists (
  select 1 from
  HMI.D_MONITOR_NODE t where
  t.mon_node_id = s.mon_node_id
)
;

-- confirm that the insertion of 
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm 
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_MN'
; 

--------------------------------------
--  insert the dimension: component status
--------------------------------------

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_d_cs;

--#EXECUTE_AT_TARGET
create table HMI.stage_d_cs (
 comp_id				integer not null,
 comp_name       varchar(254) not null,
 comp_type			varchar(17) not null,
 qmgr_name       varchar(254) not null,
   primary key (comp_id)
);

-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(comp_id) from twg.cur_comp where comptyp_cd in ( 'HMI_BROKER', 'HMI_CONFIG_MGR', 'HMI_USR_NAME_SVR', 'HMI_MSG_FLOW' ) )
 
where 
 extctl_source='TWG.CUR_COMP' and
 extctl_target='HMI.STAGE_D_CS' and
 (select count(*) from twg.cur_comp where comptyp_cd in ( 'HMI_BROKER', 'HMI_CONFIG_MGR', 'HMI_USR_NAME_SVR' , 'HMI_MSG_FLOW' )) >0 
;

--#INSERT_INTO_TARGET
insert into HMI.STAGE_D_CS
select 
 co1.comp_id as comp_id,
 co1.comp_nm as comp_name,
 co1.comptyp_cd as comp_type,
 co2.comp_nm as qmgr_name
from
 TWG.cur_Comp co1,
 TWG.cur_Comp co2,
 TWG.cur_CompReln cr1,
 TWG.Extract_Control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_CS' and
 co1.comp_id > ec.extctl_from_intseq and
 co1.comp_id <= ec.extctl_to_intseq and
 co1.comptyp_cd in ( 'HMI_BROKER', 'HMI_CONFIG_MGR', 'HMI_USR_NAME_SVR', 'HMI_MSG_FLOW') and
 cr1.comp_target_id = co1.comp_id and
 co2.comp_id = cr1.comp_source_id
group by
 co1.comp_id, co1.comp_nm, co1.comptyp_cd, co2.comp_nm  
;

--#EXECUTE_AT_TARGET
insert into HMI.D_COMP_STATUS
select * from HMI.STAGE_D_CS s
where not exists (
  select 1 from
  HMI.D_COMP_STATUS t where
  t.comp_id = s.comp_id
)
;

-- confirm that the insertion of 
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.CUR_COMP' and
 ec.extctl_target = 'HMI.STAGE_D_CS'
; 

