-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  5698-MMI
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- #   File Information: mqsi_tedw/src/tedw_apps_etl/hmi/pkg/v110/etl/sql/HMI_m05_s020_fact.db2, mqsi_tedw, amsmqsi
-- #   Revision: 1.10
-- #   Date: 8/15/02 14:39:37
-- ############################################################################
----------------------------
-- File Name: HMI_m05_s020_fact.db2
-- Last Modif: February 25 2002
-- Author: Frances Roberts
---------------------------

---------------------------
-- HMI_m05_s020_fact step
---------------------------

--#EXECUTE_AT_TARGET
insert into hmi.prune_mart_log  values ( 
  current timestamp - current timezone,  
  'hmi.f_mn_hour',
  (select PMartC_Duration from hmi.prune_mart_control 
     where Table_Name='hmi.f_mn_hour'),
  (select count(*) from hmi.f_mn_hour f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
        WHERE p.Table_Name= 'hmi.f_mn_hour')
  )      
)
;  
	
--#EXECUTE_AT_TARGET
delete from hmi.f_mn_hour f
where
	(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_hour)) > 
	(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_mn_hour');
	
	
--#EXECUTE_AT_TARGET
insert into hmi.prune_mart_log  values ( 
  current timestamp - current timezone,  
  'hmi.f_cs_hour',
  (select PMartC_Duration from hmi.prune_mart_control 
     where Table_Name='hmi.f_cs_hour'),
  (select count(*) from hmi.f_cs_hour f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
        WHERE p.Table_Name= 'hmi.f_cs_hour')
  )      
)
;  

--#EXECUTE_AT_TARGET
delete from hmi.f_cs_hour f
where
	(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_hour)) > 
	(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_cs_hour');
	
--#EXECUTE_AT_TARGET
insert into hmi.prune_mart_log  values ( 
  current timestamp - current timezone,  
  'hmi.f_mn_day',
  (select PMartC_Duration from hmi.prune_mart_control 
     where Table_Name='hmi.f_mn_day'),
  (select count(*) from hmi.f_mn_day f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
        WHERE p.Table_Name= 'hmi.f_mn_day')
  )      
)
;  
	
--#EXECUTE_AT_TARGET
delete from hmi.f_mn_day f
where
	(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
	(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_mn_day');
	
	
--#EXECUTE_AT_TARGET
insert into hmi.prune_mart_log  values ( 
  current timestamp - current timezone,  
  'hmi.f_cs_day',
  (select PMartC_Duration from hmi.prune_mart_control 
     where Table_Name='hmi.f_cs_day'),
  (select count(*) from hmi.f_cs_day f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
        WHERE p.Table_Name= 'hmi.f_cs_day')
  )      
)
;  

--#EXECUTE_AT_TARGET
delete from hmi.f_cs_day f
where
	(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
	(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_cs_day');
	
--#EXECUTE_AT_TARGET
	insert into hmi.prune_mart_log  values ( 
	  current timestamp - current timezone,  
	  'hmi.f_mn_week',
	  (select PMartC_Duration from hmi.prune_mart_control 
	     where Table_Name='hmi.f_mn_week'),
	  (select count(*) from hmi.f_mn_week f  
	     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
	        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
	        WHERE p.Table_Name= 'hmi.f_mn_week')
	  )      
	)
	;  
		
--#EXECUTE_AT_TARGET
	delete from hmi.f_mn_week f
	where
		(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
		(SELECT PMartC_Duration FROM hmi.prune_mart_control p
		WHERE p.Table_Name = 'hmi.f_mn_week');
		
		
--#EXECUTE_AT_TARGET
	insert into hmi.prune_mart_log  values ( 
	  current timestamp - current timezone,  
	  'hmi.f_cs_week',
	  (select PMartC_Duration from hmi.prune_mart_control 
	     where Table_Name='hmi.f_cs_week'),
	  (select count(*) from hmi.f_cs_week f  
	     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
	        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
	        WHERE p.Table_Name= 'hmi.f_cs_week')
	  )      
	)
	;  
	
--#EXECUTE_AT_TARGET
	delete from hmi.f_cs_week f
	where
		(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
		(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_cs_week');
	
--#EXECUTE_AT_TARGET
	insert into hmi.prune_mart_log  values ( 
	  current timestamp - current timezone,  
	  'hmi.f_mn_month',
	  (select PMartC_Duration from hmi.prune_mart_control 
	     where Table_Name='hmi.f_mn_month'),
	  (select count(*) from hmi.f_mn_month f  
	     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
	        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
	        WHERE p.Table_Name= 'hmi.f_mn_month')
	  )      
	)
	;  
		
--#EXECUTE_AT_TARGET
	delete from hmi.f_mn_month f
	where
		(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
		(SELECT PMartC_Duration FROM hmi.prune_mart_control p
		WHERE p.Table_Name = 'hmi.f_mn_month');
		
		
--#EXECUTE_AT_TARGET
	insert into hmi.prune_mart_log  values ( 
	  current timestamp - current timezone,  
	  'hmi.f_cs_month',
	  (select PMartC_Duration from hmi.prune_mart_control 
	     where Table_Name='hmi.f_cs_month'),
	  (select count(*) from hmi.f_cs_month f  
	     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
	        (SELECT PMartC_Duration FROM hmi.Prune_Mart_Control p
	        WHERE p.Table_Name= 'hmi.f_cs_month')
	  )      
	)
	;  
	
--#EXECUTE_AT_TARGET
	delete from hmi.f_cs_month f
	where
		(DATE( CURRENT timestamp - CURRENT timezone )-DATE(f.meas_date)) > 
		(SELECT PMartC_Duration FROM hmi.prune_mart_control p
	WHERE p.Table_Name = 'hmi.f_cs_month');

--------------------------------------------------------------------------------
-- insert the facts for Monitor nodes 

-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(msmt_id) from twg.msmt),
 extctl_to_dttm =  ( select max(timestamp(msmt_strt_dt,msmt_strt_tm)) from twg.msmt)
where 
 extctl_source='TWG.MSMT' and
 extctl_target='HMI.STAGE_F_MN_HOUR' and
 (select count(*) from twg.msmt ) >0  
;

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_f_mn_hour;

--#EXECUTE_AT_TARGET
create table hmi.stage_f_mn_hour 
(
  mon_node_id   integer not null,
  host_id		integer not null,
  metric_id integer not null,
  meas_hour timestamp not null,
  min_value float,
  max_value float,
  avg_value float,
	total_value float,
	sample_count integer,
	primary key (mon_node_id, host_id, metric_id , meas_hour )
);
;

--#INSERT_INTO_TARGET
insert into HMI.STAGE_F_MN_Hour
select 
 c1.comp_id as mon_node_id, 
 cr5.comp_source_id as host_id,
 m.msmttyp_id as metric_id, 
 timestamp(m.msmt_strt_dt,m.msmt_strt_tm) as meas_hour, 
 avg(m.msmt_min_val) as min_value, 
 avg(m.msmt_max_val) as max_value, 
 avg(m.msmt_avg_val) as avg_value,
 avg(m.msmt_tot_val) as total_value,
 avg(m.msmt_smpl_cnt) as sample_count
from  
 TWG.Msmt m,
 TWG.cur_Comp c1,
 TWG.cur_CompReln cr1,
 TWG.cur_CompReln cr2,
 TWG.cur_CompReln cr3,
 TWG.cur_CompReln cr4,
 TWG.cur_CompReln cr5,
 TWG.Extract_control ec
where  
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'HMI.STAGE_F_MN_HOUR' and
 m.msmt_id > ec.extctl_from_intseq and
 m.msmt_id <= ec.extctl_to_intseq and
 m.tmsum_cd='H' and
 c1.comp_id=m.comp_id and
 c1.comptyp_cd = 'HMI_MONITOR_NODE' and
 cr1.comp_target_id=c1.comp_id and
 cr2.comp_target_id=cr1.comp_source_id and 
 cr3.comp_target_id=cr2.comp_source_id and 
 cr4.comp_target_id=cr3.comp_source_id and 
 cr5.comp_target_id=cr4.comp_source_id 
group by
 c1.comp_id, cr5.comp_source_id, m.msmttyp_id, m.msmt_strt_dt, m.msmt_strt_tm 
;

--#EXECUTE_AT_TARGET
insert into HMI.f_mn_hour
select * from HMI.stage_f_mn_hour
;

-- confirm that the insertion of 
-- the facts for Oracle databases 
-- has succeeded.
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm  
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'HMI.STAGE_F_MN_HOUR'
; 

-- insert the facts for component status 

-- get the high value for the window

update TWG.Extract_Control set 
 extctl_to_intseq =  ( select max(msmt_id) from twg.msmt),
 extctl_to_dttm =  ( select max(timestamp(msmt_strt_dt,msmt_strt_tm)) from twg.msmt)
where 
 extctl_source='TWG.MSMT' and
 extctl_target='HMI.STAGE_F_CS_HOUR' and
 (select count(*) from twg.msmt ) >0  
;

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table HMI.stage_f_cs_hour;

--#EXECUTE_AT_TARGET
create table hmi.stage_f_cs_hour 
(
  comp_id   integer not null,
  host_id		integer not null,
  metric_id integer not null,
  meas_hour timestamp not null,
  min_value float,
  max_value float,
  avg_value float,
	total_value float,
	sample_count integer,
	primary key (comp_id, host_id, metric_id , meas_hour )
);


--#INSERT_INTO_TARGET
insert into HMI.STAGE_F_CS_Hour
select 
 c1.comp_id as comp_id, 
 cr2.comp_source_id as host_id,
 m.msmttyp_id as metric_id, 
 timestamp(m.msmt_strt_dt,m.msmt_strt_tm) as meas_hour, 
 avg(m.msmt_min_val) as min_value, 
 avg(m.msmt_max_val) as max_value, 
 avg(m.msmt_avg_val) as avg_value,
 avg(m.msmt_tot_val) as total_value,
 avg(m.msmt_smpl_cnt) as sample_count
from  
 TWG.Msmt m,
 TWG.cur_Comp c1,
 TWG.cur_CompReln cr1,
 TWG.cur_CompReln cr2,
 TWG.Extract_control ec
where  
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'HMI.STAGE_F_CS_HOUR' and
 m.msmt_id > ec.extctl_from_intseq and
 m.msmt_id <= ec.extctl_to_intseq and
 m.tmsum_cd='H' and
 c1.comp_id=m.comp_id and
 c1.comptyp_cd in ( 'HMI_BROKER', 'HMI_CONFIG_MGR', 'HMI_USR_NAME_SVR', 'HMI_MSG_FLOW' ) and
 cr1.comp_target_id=c1.comp_id and
 cr2.comp_target_id=cr1.comp_source_id 
group by
 c1.comp_id, cr2.comp_source_id, m.msmttyp_id, m.msmt_strt_dt, m.msmt_strt_tm 
;

--#EXECUTE_AT_TARGET
insert into HMI.f_cs_hour
select * from HMI.stage_f_cs_hour
;

-- confirm that the insertion of 
-- the facts has succeeded.
-- insert a row in the TWG.EXTRACT_LOG

insert into twg.extract_log ( extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq, extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm, extlog_to_dttm )
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - CURRENT timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm 
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'HMI.STAGE_F_CS_HOUR'
; 

