-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  5698-MMI
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- #   File Information: %W%
-- #   Revision: %I%
-- #   Date: %G% %U%
-- ############################################################################
-----------------------------------------------------------------------
-- Insert data into control table for pruning data from all fact tables.
-- A date duration is decimal(8,0) and has the format yyyymmdd.
-----------------------------------------------------------------------

create TABLE hmi.Prune_Mart_Ctl_tmp(
       Table_Name           VARCHAR(120) NOT NULL,
       PMartC_Duration      DECIMAL(8,0) NOT NULL
) 
;

INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_mn_hour', 00000300);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_cs_hour', 00000300);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_mn_day', 00000300);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_cs_day', 00000300);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_mn_week', 00010000);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_cs_week', 00010000);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_mn_month', 00010000);
INSERT INTO hmi.Prune_Mart_Ctl_tmp VALUES ('hmi.f_cs_month', 00010000);

INSERT INTO hmi.Prune_Mart_Control
SELECT 
   s.Table_Name AS Table_Name,
   s.PMartC_Duration AS PMartC_Duration
FROM 
   hmi.Prune_Mart_Ctl_tmp s
WHERE NOT EXISTS
( 
  SELECT 1 FROM
  hmi.Prune_Mart_Control t
  WHERE
  t.Table_Name = s.Table_Name
);

drop table hmi.Prune_Mart_Ctl_tmp;

